#include "montecarlocpp.h"

double random_uniform_0_1(){
  //rand() retourne un entier entre 0 et RAND_MAX
  return ((double)rand())/RAND_MAX;
}

double random_normal(){
  double U1, U2, V1, V2;
  double S;
  do{
    U1 = random_uniform_0_1();
    U2 = random_uniform_0_1();
    V1 = 2.0 * U1 - 1.0;
    V2 = 2.0 * U2 - 1.0;
    S = pow(V1,2) + pow(V2,2); 
  }while (S>=1);

    return V1 *  sqrt( (-2.0 * log(S)) / S);
}

double _stdcall mccallcpp(double S, double K, double r, double sigma, double time, double nbsim){
	double R = (r - 0.5 * pow(sigma, 2)) * time;
	double sigt= sigma*sqrt(time);
	double sum=0.0;
	double St=0.0;

	for(int i = 0; i < nbsim; i++){
		St = S * exp(R+sigt*random_normal());
		sum += max(0.0, St-K);
	}

	return exp(-r*time) * (sum / ((double) nbsim));
}
